function PreClassification
% Builds the performance matrix, the portfolios, the training/test sets and 
% saves the suitable results before the SATzilla classification starts.

% Given an instance name, returns the corresponding ID.
function Index = instToIndex(name)
    Index = find(cellfun(@(x) strcmp(x, name), INSTs));
end

% Given a solver name, returns the corresponding ID.
function Index = solverToIndex(solver)
    Index = find(cellfun(@(x) strcmp(x, solver), SOLVERs));
end

% Build the performance matrix P so that P(i, j) is the runtime of j-th
% solver on the i-th instance.
perf_file = 'perf_matrix_cop.csv';
fid = fopen(perf_file);
perf = textscan(fid, '%s%s%s%s%s%s%s%s%s%s%s%s%s%s');
NUM_INST = 2670;
NUM_SOLV = 12;
INSTs = cell(NUM_INST, 1);
SOLVERs = cell(NUM_SOLV + 1, 1);
P = zeros(NUM_INST, NUM_SOLV + 1);
for i = 1:NUM_INST
    for j = 1:(NUM_SOLV + 1)
        INSTs{i} = perf{1}{i + 1};
          if i == 1
              SOLVERs{j} = perf{j + 1}{1};
          end
          P(i, j) = eval(perf{j + 1}{i + 1});
    end
end

st(1) = solverToIndex('g12cpx');
st(2) = solverToIndex('nosolver');
st(3) = solverToIndex('izplus');
st(4) = solverToIndex('ortools');
st(5) = solverToIndex('g12fd');
st(6) = solverToIndex('mistral');
st(7) = solverToIndex('jacop');
st(8) = solverToIndex('gecode');
st(9) = solverToIndex('g12lazyfd');
st(10) = solverToIndex('minisatid');
st(11) = solverToIndex('bprolog');
st(12) = solverToIndex('g12mip');
st(13) = solverToIndex('fzn2smt');

st

end
