'''
Split dataset in train and test set.
'''

import sys
import os
import pickle

PRED_PATH = '/public/xcsp_instances/new/predictions/cop/off_the_shelf/pred_no_sel/2_solvers/IBk/no-oversamp/RemNorm/no_sel/output_IBk_RemNorm_no_sel_'
OUT_PATH = '/public/xcsp_instances/new/dataset/cop/train_test/'
DATA_PATH = '/public/xcsp_instances/new/dataset/cop/cop_final_minizinc'

def main(args):
  data_set = set([])
  dataset_file = open(DATA_PATH)
  line = dataset_file.readline()
  while line:
    data_set.add(line[0:-1])
    line = dataset_file.readline()

  for rep in range(1, 6):
    for fold in range(1, 6):
      suffix = 'rep' + str(rep) + '_fold' + str(fold)
      test_set = set([])
      test_file = open(PRED_PATH + suffix)
      test_file.readline()
      line = test_file.readline()
      while line:
        row = line.split()
        if len(row) > 0:
          inst = row[-1][1:-1]
          test_set.add(inst)
        line = test_file.readline()
      train_set = data_set - test_set
      with open(OUT_PATH + 'train_' + suffix, 'w') as outfile:
        pickle.dump(train_set, outfile)
      with open(OUT_PATH + 'test_' + suffix, 'w') as outfile:
        pickle.dump(test_set, outfile)

if __name__ == '__main__':
  main(sys.argv[1:])
